<template>
            <section>
                <div class="input-pesquisa">
                    <input class="input is-info" type="text" placeholder="Pesquisar produto" v-model="state.nomeProduto">
                </div>
                <div class="botoes-acoes">
                    <button class="button is-normal" @click="$router.push({ name: 'cadastro' })">Cadastro</button>
                    <button class="button is-normal" @click="$router.push({ name: 'login' })" v-if="! sessao.recuperaSessaoToken().length">Login</button>
                    <div v-else>
                        Bem vindo {{sessao.recuperaSessao().user.name}}
                        <button class="button is-normal" @click="logout">Logout</button>
                    </div>
                    <Carrinho class="carrinho"/>
                </div>
            </section>            
</template>

<script>
import Carrinho from "../carrinho/Index"
import { setState } from '@/store'
import { reactive, watch } from '@vue/runtime-core'
import sessao from '../../../services/sessao/index'
import { requestPOST } from '../../../services/http/index'
import { getState } from '../../../store'

export default {
    components: {
        Carrinho
    },
    setup () {
        const state = reactive({
            nomeProduto: null
        })
        const logout = () => {
            requestPOST(`${getState.env.VUE_APP_URL_API_LOJA}/logout`).then(response => {
                if (response.status === 200) {
                    sessao.removeSessao()
                    window.location.href = '/'
                }
            }).catch(() => {
                sessao.removeSessao()
                window.location.href = '/'
            })
        }
        watch(
            () => state.nomeProduto,
            (nomeProduto) => {
                setState('resultadoPesquisaProduto', nomeProduto)
            }
        )

        return {
            state,
            sessao,
            logout
        }        
    }
    
}
</script>
<style lang="scss" scoped>
    .botoes-acoes {
        float: right;
        min-width: 14em;
        justify-content: space-between;
        display: flex;
    }
    .botoes-acoes button {
        margin-left: 5px;
    }
    .input {
        width: 100%;
    }
    section {
        display: flex;
        flex: 1;
        max-width: 77%;
        padding: 1em 0 1em 0;
    }
    .input-pesquisa {
        width: 100%;
        margin-right: 15px;
    }
    .carrinho {
        margin-left: 15px;
    }
</style>